package eu.mhsl.minecraft.WorldMuseum.listener;

import eu.mhsl.minecraft.WorldMuseum.Main;
import net.kyori.adventure.util.Ticks;
import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.Material;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

import java.util.Objects;

public class PlayerListener implements Listener {
    @EventHandler
    public void onJoin(PlayerJoinEvent event) {
        event.getPlayer().setGameMode(GameMode.SURVIVAL);
        Main.instance().getWorlds().forEach(world -> {
            if (world.isDefaultWorld()) world.addViewer(event.getPlayer());
        });
        event.getPlayer().addPotionEffect(
            new PotionEffect(PotionEffectType.HASTE, PotionEffect.INFINITE_DURATION, 15, false, false, false)
        );
    }

    @EventHandler
    public void onBreak(BlockBreakEvent event) {
        Material material = event.getBlock().getType();
        Bukkit.getScheduler().scheduleSyncDelayedTask(
            Main.instance(),
            () -> Objects.requireNonNull(Bukkit.getWorld(event.getBlock().getWorld().getName())).setType(event.getBlock().getLocation(), material), Ticks.TICKS_PER_SECOND * 5
        );
    }

    @EventHandler
    public void onPlace(BlockPlaceEvent event) {
        event.setCancelled(true);
    }
}
